// Class: Date
class Date {
private:
    int day;
    int month;
    int year;
    int hour;
    int minute;

public:
    void setDay(int d);
    int getDay() ;

    void setMonth(int m);
    int getMonth() ;

    void setYear(int y);
    int getYear() ;

    void setHour(int h);
    int getHour() ;

    void setMinute(int m);
    int getMinute() ;

    friend  ostream& operator<<( ostream& out,  Date& date);
    friend  istream& operator>>( istream& in, Date& date);
};

// Class: Food
class Food {
private:
     string type; // Economic or Business
     string meal;

public:
    void setType(  string& t);
     string getType() ;

    void setMeal(  string& m);
     string getMeal() ;

    friend  ostream& operator<<( ostream& out,  Food& food);
    friend  istream& operator>>( istream& in, Food& food);
};

// Class: Airport
class Airport {
protected:
     string domesticFlights;
     string foreignFlights;

public:
    virtual void addFlight(  string& flight);
    virtual void removeFlight(  string& flight);
    virtual void displayFlights() ;
};

// Class: DomesticFlights (Derived from Airport)
class DomesticFlights : public Airport {
private:
     string originCity;
     string destinationCity;
    Date flightDate;
     string planeName;
    bool isCancelled;

public:
    void setOriginCity(  string& city);
     string getOriginCity() ;

    void setDestinationCity(  string& city);
     string getDestinationCity() ;

    void setFlightDate( Date& date);
    Date getFlightDate() ;

    void setPlaneName(  string& name);
     string getPlaneName() ;

    void setIsCancelled(bool cancelled);
    bool getIsCancelled() ;
};

// Class: DomesticCities
class DomesticCities {
private:
     string cities[10];

public:
    void addCity(string& city);
     string getCities() ;
};

// Class: ForeignFlights (Derived from Airport)
class ForeignFlights : public Airport {
private:
     string originCity;
     string destinationCity;
    Date flightDate;
     string planeName;
    bool isCancelled;

public:
    void setOriginCity(string& city);
     string getOriginCity() ;

    void setDestinationCity(string& city);
     string getDestinationCity() ;

    void setFlightDate(Date& date);
    Date getFlightDate() ;

    void setPlaneName(string& name);
     string getPlaneName() ;

    void setIsCancelled(bool cancelled);
    bool getIsCancelled() ;
};

// Class: ForeignCities
class ForeignCities {
private:
     string cities[10];

public:
    void addCity(string& city);
     string getCities() ;
};

// Class: Customer
class Customer {
private:
     string name;
    double balance;
     string purchasedFlights;

public:
    void setName(string& n);
     string getName() ;

    void setBalance(double b);
    double getBalance() ;

    void addPurchasedFlight(string& flight);
     string getPurchasedFlights() ;

    void refundTicket(string& flight);
};

// Class: Admin
class Admin {
private:
     string adminName;
     string adminPassword;

public:
    void setAdminName(string& name);
     string getAdminName() ;

    void setAdminPassword(string& password);
    string getAdminPassword() ;

    bool authenticate(string& name, string& password) ;
    void manageFlights();
};

// Class: Tax
class Tax {
public:
    double calculateTax(double price, double percentage) ;
};
